;*********************** RS232 transmitter *****************************
; pp, pp p  ᫥⥫ p䥩ᮬ AVR.
;  p  p 裡  ppp 
; p p ⫠ pp.
; pp pp p᪨ 뫪 ⮢   p
; p⥫쭮 1 ᥪ. 祭 p   p p-
; p.  砥 p  ,  p  "
; p". pp pp: 9600 /c, 8 , 1 ⮯ 
; p  pp 4.0 .
;  p樨 믮  pp뢠.
;** (c)  ..  **********************************************
;device 8515
;********* ᠭ ⠭ *******************************************
.equ  Asec   = 15   ;⠭ pp㧪 pp ⠩p STimer
                    ; pp p p = 1 ᥪ
                    ;Asec = 1000000 div (N*256 / 4MHz), N=1024=Prescaler

;********* ᠭ p *****************************************
.def STimer  = r25  ;pp ⠩p, pp p p
                    ; p祩 ⮢,
                    ;1 "⨪" ⠩p = 横 p ⠩p T0
.def Tdata   = r15  ;p , pp p  p祩
.def Temp    = r17

;********* 祥 ⥫ pp **************************************

	.org 0        ;砫 p pp
	rjmp Start    ;p室  p祩  pp (p Reset)
	reti          ;pp뢠 Int0  ᯮ, ⮨ "誠"
	reti          ;pp뢠 Int1  ᯮ
	reti          ;pp뢠 T1 Capture  ᯮ
	reti          ;pp뢠 T1 CompareA  ᯮ
	reti          ;pp뢠 T1 CompareB  ᯮ
	reti          ;pp뢠 T1 Overflow  ᯮ
        rjmp  IntT0   ;p室  p楤p 㦨 pp뢠 T0 Overflow
	reti          ;pp뢠 SPI  ᯮ, ⮨ "誠"
        rjmp  IntRx   ;p室  p楤p 㦨 pp뢠 UART Rx
	reti          ;pp뢠 UART Data Reg Empty  ᯮ
        rjmp  IntTx   ;p室  p楤p 㦨 pp뢠 UART Tx
	reti          ;pp뢠 Analog Comparator  ᯮ

	.org  $10     ;⠭ 砫 p pp
Start:
        ldi     Temp,0
	out	SPH,Temp    
        ldi     Temp,$DF
	out	SPL,Temp    ;⠭ ⥪   $D0..$DF
	clr     Tdata       ;⠭ 砫쭮 祭  
	ldi     STimer,Asec ;⠭ p  뫪
        ldi     Temp,25
;        ldi     Temp,51     ;8 MHz
	out	UBRR,r17    ;᪮p 9600 /
        ldi     Temp,$D8
        out	UCR,Temp    ;pp訬 pp뢠  Rx,Tx, p pp襭
        ldi     Temp,$5
        out	TCCR0,Temp  ;᪠ ⠩p T0, Ck/1024
        ldi     Temp,$2
        out	TIMSK,Temp  ;pp訬 pp뢠  T0
        sbi     DDRD,1      ;en Tx Output
        sbi     DDRD,3      ;en Beep Output
        sei                 ;pp訬 pp뢠

	rcall	IntTx       ;樨p㥬 pp뢠

        ;稩 横 pp, 祣  .
Work:
	rjmp	Work

;********* p楤p pp뢠  p ⠩p T0 *************
IntT0:
	dec     STimer      ;1 "⨪" pp ⠩p
        brne    NoTr
	ldi     STimer,Asec ;᫨ p,  pp㧨,
	inc 	Tdata       ;㢥稬 p 
        cbi     PortD,3     ;make "Tick" on PortD.3
        sbrc    Tdata,0
        sbi     PortD,3
itTx:
        sbi     UCR,6       ;pp訬 pp뢠  Tx
NoTr:	
        reti                ; p楤p 㦨 pp뢠

;****** p楤p pp뢠  p Rx  ᫥⥫쭮 p **
IntRx:
        push    Temp        ;p R17  ⥪
	in	Temp,UDR    ;⠥ p ,
rxLoop:	sbis    USR,5       ; p襭 p p饣 
        rjmp    rxLoop
	out	UDR,Temp    ;p頥 p  ("")
        pop     Temp        ;⠭ 祭 R17
	reti                ;室  p楤p 㦨 pp뢠

;****** p楤p pp뢠  p Tx  ᫥⥫쭮 p **
IntTx:
	out	UDR,Tdata   ;p
        cbi     UCR,6       ;no   pp뢠  Tx
Skip:	reti                ;室  p楤p 㦨 pp뢠

