;*********************** RS232 transmitter *****************************
; pp, pp p  ᫥⥫ p䥩ᮬ ATmega.
;  p  p 裡  ppp 
; p p ⫠ pp.
; pp pp p᪨ 뫪 ⮢   p
; p⥫쭮 1 ᥪ. 祭 p   p p-
; p.  砥 p  ,  p  "
; p". pp pp: 9600 /c, 8 , 1 ⮯ 
; p  pp 4.0 .
;  p樨 믮  pp뢠.
;** (c)  ..  **********************************************
;device ATmega
;********* ᠭ ⠭ *******************************************
.equ  Asec   = 15   ;⠭ pp㧪 pp ⠩p STimer
                    ; pp p p = 1 ᥪ
                    ;Asec = 1000000 div (N*256 / 4MHz), N=1024=Prescaler
.equ  ck1024 =  7   ;Timer0 Prescaler = Clock/1024
.equ  dv9600 = 25   ;UBRR divider to set 9600 Baud rate @4Mhz
.equ  Umode  = $D8  ;UART mode: pp訬 pp뢠  Rx,Tx, p pp襭
.equ  tiMask = 1    ;Timer interrupts Mask
.equ  TXCIE  = 6    ;Tx Interrupts Enable
.equ  UDRE   = 5    ;UDR is Empty
.equ  Stack  = $DF  ;Stack Top

;********* ᠭ p *****************************************
.def STimer  = r25  ;pp ⠩p, pp p p
                    ; p祩 ⮢,
                    ;1 "⨪" ⠩p = 横 p ⠩p T0
.def Tdata   = r15  ;p , pp p  p祩
.def Temp    = r17

;********* 祥 ⥫ pp **************************************
;Interrupts for Mega
	.org 0        ;砫 p pp
	rjmp Start    ;p室  p祩  pp (p Reset)
        nop
	reti          ;pp뢠 Int0  ᯮ, ⮨ "誠"
        nop
	reti          ;pp뢠 Int1  ᯮ
        nop
	reti          ;pp뢠 Int2  ᯮ
        nop
	reti          ;pp뢠 Int3  ᯮ
        nop
	reti          ;pp뢠 Int4  ᯮ
        nop
	reti          ;pp뢠 Int5  ᯮ
        nop
	reti          ;pp뢠 Int6  ᯮ
        nop
	reti          ;pp뢠 Int7  ᯮ
        nop
	reti          ;pp뢠 T2 Compare  ᯮ
        nop
	reti          ;pp뢠 T2 Overflow  ᯮ
        nop
	reti          ;pp뢠 T1 Capture  ᯮ
        nop
	reti          ;pp뢠 T1 CompareA  ᯮ
        nop
	reti          ;pp뢠 T1 CompareB  ᯮ
        nop
	reti          ;pp뢠 T1 Overflow  ᯮ
        nop
	reti          ;pp뢠 T0 Compare  ᯮ
        nop
        rjmp  IntT0   ;p室  p楤p 㦨 pp뢠 T0 Overflow
        nop
	reti          ;pp뢠 SPI  ᯮ, ⮨ "誠"
        nop
        rjmp  IntRx   ;p室  p楤p 㦨 pp뢠 UART Rx
        nop
	reti          ;pp뢠 UART Data Reg Empty  ᯮ
        nop
        rjmp  IntTx   ;p室  p楤p 㦨 pp뢠 UART Tx
        nop
	reti          ;pp뢠 ADC  ᯮ
        nop
	reti          ;pp뢠 EE_Ready  ᯮ
        nop
	reti          ;pp뢠 Analog Comparator  ᯮ

	.org  $30     ;⠭ 砫 p pp
Start:
        ldi     Temp,High(Stack)
	out	SPH,Temp    
        ldi     Temp,Low(Stack)
	out	SPL,Temp    ;⠭ ⥪   $D0..$DF
	clr     Tdata       ;⠭ 砫쭮 祭  
	ldi     STimer,Asec ;⠭ p  뫪
        ldi     Temp,dv9600 ;4 MHz
	out	UBRR,r17    ;᪮p 9600 /
        ldi     Temp,Umode
        out	UCR,Temp    ;pp訬 pp뢠  Rx,Tx, p pp襭
        ldi     Temp,ck1024
        out	TCCR0,Temp  ;᪠ ⠩p T0, Ck/1024
        ldi     Temp,tiMask
        out	TIMSK,Temp  ;pp訬 pp뢠  T0
        sbi     DDRE,1      ;en Tx Output
        sei                 ;pp訬 pp뢠

	rcall	IntTx       ;樨p㥬 pp뢠

        ;稩 横 pp, 祣  .
Work:
	rjmp	Work

;********* p楤p pp뢠  p ⠩p T0 *************
IntT0:
	dec     STimer      ;1 "⨪" pp ⠩p
        brne    NoTr
	ldi     STimer,Asec ;᫨ p,  pp㧨,
	inc 	Tdata       ;㢥稬 p 
        sbi     UCR,TXCIE   ;pp訬 pp뢠  Tx
NoTr:	
        reti                ; p楤p 㦨 pp뢠

;****** p楤p pp뢠  p Rx  ᫥⥫쭮 p **
IntRx:
        push    Temp        ;p R17  ⥪
	in	Temp,UDR    ;⠥ p ,
rxLoop:	sbis    USR,UDRE    ; p襭 p p饣 
        rjmp    rxLoop
	out	UDR,Temp    ;p頥 p  ("")
        pop     Temp        ;⠭ 祭 R17
	reti                ;室  p楤p 㦨 pp뢠

;****** p楤p pp뢠  p Tx  ᫥⥫쭮 p **
IntTx:
	out	UDR,Tdata   ;p
        cbi     UCR,TXCIE   ;no   pp뢠  Tx
Skip:	reti                ;室  p楤p 㦨 pp뢠

